/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package db;

import java.io.IOException;
import java.sql.Connection;
import java.sql.Driver;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import model.Proizvod;

/**
 *
 * @author student1
 */
public class DatabaseBroker {
    private Connection connection;

    public DatabaseBroker() {
    }
    
    public void konektujSeNaBazuAccessPrviNacin() throws ClassNotFoundException, InstantiationException, IllegalAccessException, SQLException{
        
        Driver driver= (Driver)Class.forName("sun.jdbc.odbc.JdbcOdbcDriver").newInstance();
        String url="jdbc:odbc:Racuni";
        String user="";
        String password="";
        
        Properties props=new Properties();
        props.put("user", user);
        props.put("password", password);
        
        try {
            connection=driver.connect(url, props);
            connection.setAutoCommit(false);
        } catch (SQLException ex) {
            System.out.println("Greska pri konektovanju na Access!");
            throw ex;
        }
        System.out.println("Uspesno smo konektovani na Access!");
    }
    
    public void konektujSeNaBazuMySQLPrviNacin() throws ClassNotFoundException, InstantiationException, IllegalAccessException, SQLException{
        
        Driver driver= (Driver)Class.forName("com.mysql.jdbc.Driver").newInstance();
        String url="jdbc:mysql://localhost:3306/racuni";
        String user="root";
        String password="";
        
        Properties props=new Properties();
        props.put("user", user);
        props.put("password", password);
        
        try {
            connection=driver.connect(url, props);
            connection.setAutoCommit(false);
        } catch (SQLException ex) {
            System.out.println("Greska pri konektovanju na MySQL!");
            throw ex;
        }
        System.out.println("Uspesno smo konektovani na MySQL!");
    }
    
    public void konektujSeNaBazuAccessDrugiNacin() throws ClassNotFoundException, SQLException{
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        String url="jdbc:odbc:Racuni";
        String user="";
        String password="";
        connection=DriverManager.getConnection(url, user, password);
        connection.setAutoCommit(false);
        System.out.println("Uspesno smo konektovani na Access!");
    }
    
    public void konektujSeNaBazuMySQLDrugiNacin() throws ClassNotFoundException, SQLException{
        Class.forName("com.mysql.jdbc.Driver");
        String url="jdbc:mysql://localhost:3306/racuni";
        String user="root";
        String password="";
        connection=DriverManager.getConnection(url, user, password);
        connection.setAutoCommit(false);
        System.out.println("Uspesno smo konektovani na MySQL!");
    }
    
    public void konektujSeNaBazu() throws IOException, ClassNotFoundException, SQLException{
        Class.forName(Util.getInstance().getDriver());
        String url=Util.getInstance().getUrl();
        String user=Util.getInstance().getUser();
        String password=Util.getInstance().getPassword();
        connection=DriverManager.getConnection(url, user, password);
        connection.setAutoCommit(false);
        System.out.println("Uspesno smo konektovani na bazu!");
    }
    
    public void zatvoriKonekciju() throws SQLException{
        connection.close();
        System.out.println("Zatvaranje baze!");
    }
    
    public void commitTransakcije() throws SQLException{
        connection.commit();
    }
    
    public void rollbackTransakcije() throws SQLException{
        connection.rollback();
    }
    
    public void insertProizvod(Proizvod p) throws SQLException{
        String upit="INSERT INTO Proizvod (proizvodID, naziv, cena) VALUES ("+p.getProizvodID()+", '"+p.getNaziv()+"', "+p.getCena()+")";
        System.out.println(upit);
        Statement statement=connection.createStatement();
        statement.executeUpdate(upit);
        statement.close();
    }
    
    public void insertProizvodBoljiNacin(Proizvod p) throws SQLException{
        String upit="INSERT INTO Proizvod (proizvodID, naziv, cena) VALUES (?,?,?)";
        System.out.println(upit);
        PreparedStatement preparedStatement=connection.prepareStatement(upit);
        preparedStatement.setInt(1, p.getProizvodID());
        preparedStatement.setString(2, p.getNaziv());
        preparedStatement.setDouble(3, p.getCena());
        preparedStatement.executeUpdate();
        preparedStatement.close();
    }
    
    public void insertProizvodi(List<Proizvod> proizvodi) throws SQLException{
        String upit="INSERT INTO Proizvod (proizvodID, naziv, cena) VALUES (?,?,?)";
        System.out.println(upit);
        PreparedStatement preparedStatement=connection.prepareStatement(upit);
        
        for (Proizvod proizvod : proizvodi) {
            preparedStatement.setInt(1, proizvod.getProizvodID());
            preparedStatement.setString(2, proizvod.getNaziv());
            preparedStatement.setDouble(3, proizvod.getCena());
            preparedStatement.executeUpdate();
        }
        
        preparedStatement.close();
    }
    
    public List<Proizvod> getAllProizvod() throws SQLException{
        String upit="SELECT proizvodID, naziv, cena FROM proizvod";
        System.out.println(upit);
        Statement statement=connection.createStatement();
        ResultSet rs=statement.executeQuery(upit);
        ArrayList<Proizvod> proizvodi=new ArrayList<>();
        while(rs.next()){
            Proizvod proizvod=new Proizvod();
            proizvod.setProizvodID(rs.getInt("proizvodID"));
            proizvod.setNaziv(rs.getString("naziv"));
            proizvod.setCena(rs.getDouble("cena"));
            proizvodi.add(proizvod);
        }
        rs.close();
        statement.close();
        
        return proizvodi;
    }
    
}
